<script language="VBScript" type="text/vbscript" runat="server">

Class cUpload
	public TmpDir, TmpFile, RowEndReplace
	dim m_readstep, m_totalbytes, m_filescount, m_hasform, m_status
	dim brw, dictFiles, dictForm, m_files(), m_formitems()

   ' BEGIN EVENT HANDLERS '
   
	Private Sub Class_Initialize()
		Status = 103 ' neprobhl Save '
		TotalBytes = Request.TotalBytes
		if not IsEmpty then
			TmpDir = ""
			TmpFile = ""
			RowEndReplace = ""
			ReadStep = 32767
			FilesCount = 0
			set brw = Server.CreateObject("IMegaSoftware.BinaryRW")
			HasForm = false
		end if
	End sub

	Private Sub Class_Terminate()
		Clear()
		set brw = nothing
		set dictFiles = nothing
		set dictForm = nothing
	End Sub	
	
    ' END EVENT HANDLERS '
    ' BEGIN PROPERTIES '
	
	Public Property Get IsEmpty()
        IsEmpty = CBool(TotalBytes=0)
	End Property
	
	Private Property Let ReadStep(i_readstep)
		m_readstep = i_readstep
	End Property
	Private Property Get ReadStep()
        ReadStep = m_readstep
	End Property

	Private Property Let TotalBytes(i_totalbytes)
		m_totalbytes = i_totalbytes
	End Property
	Private Property Get TotalBytes()
        TotalBytes = m_totalbytes
	End Property

	Private Property Let FilesCount(i_filescount)
		m_filescount = i_filescount
	End Property
	Public Property Get FilesCount()
        FilesCount = m_filescount
	End Property

	Private Property Let HasForm(i_hasform)
		m_hasform = i_hasform
	End Property
	Public Property Get HasForm()
        HasForm = m_hasform
	End Property

	Private Property Let Status(i_status)
		m_status = i_status
	End Property
	Public Property Get Status()
        Status = m_status
	End Property

	Public Property Get Files()
		dim tmp(), i
		ReDim tmp(FilesCount-1)
		for i = 0 to (FilesCount-1)
			tmp(i) = CLng(i)
		next
		Files = tmp
	end property

	Public Property Get FormItems()
		if IsObject(dictForm) then
			FormItems = dictForm.Keys
		else
			FormItems = Array()		
		end if
	end property
	
    ' END PROPERTIES '
	' BEGIN METHODS '

	
	Public Sub Save()
		dim tmp, i
		if not IsEmpty then
			tmp = brw.FD_Init(TmpDir, TmpFile, RowEndReplace)
			if tmp<>0 then
				for i=0 to TotalBytes step ReadStep
	      			brw.FD_Decode Request.BinaryRead(ReadStep)
				next
				Status = brw.FD_EndDecode()
				if Status = 0 then CreateCollections
			else
				Status = 102 ' selhal init '
			end if
		else
			Status = 101 ' je to przdn '
		end if
	End Sub

	Public Sub Clear()
		dim b
		if not IsEmpty then
			Status = brw.FD_DeleteTMPFiles()
		    brw.FD_FreeData
		else
			Status = 0
		end if
	End Sub

	Private Sub CreateCollections
		dim ic, i, nfile, ii, fi, last

		last = -1
		ic = brw.FD_GetItemsCount()
		HasForm = CBool(ic>0)

		if HasForm then
			set dictForm = Server.CreateObject("Scripting.Dictionary")
			for i = 0 to (ic-1)
				if dictForm.Exists(CStr(brw.FD_GetItemName(i))) then
					dictForm(CStr(brw.FD_GetItemName(i))) = dictForm(CStr(brw.FD_GetItemName(i))) & "," & CStr(brw.FD_GetItemValue(i))
					FormItem(brw.FD_GetItemName(i)).AddValue brw.FD_GetItemValue(i)
				else
					dictForm.Add CStr(brw.FD_GetItemName(i)), CStr(brw.FD_GetItemValue(i))
					ReDim Preserve m_formitems(last+1)
					last = UBound(m_formitems)
					set fi = new cFormItem
					fi.Name = brw.FD_GetItemName(i)
					fi.AddValue brw.FD_GetItemValue(i)
					set m_formitems(last) = fi
				end if
				set fi = nothing
			next
		end if

		last = brw.FD_GetFilesCount()-1
		if last >= 0 then
			for i = 0 to last
				set dictFiles = Server.CreateObject("Scripting.Dictionary")
				set nfile = new cFile
				with nfile
					.Name = brw.ExtractFileName(brw.FD_GetFileHeaderName(i))
					.NameOnly = brw.ExtractFileNameOnly(brw.FD_GetFileHeaderName(i))
					.Extension = brw.ExtractFileExt(brw.FD_GetFileHeaderName(i))
					.Size = brw.FileSize(brw.FD_GetFileName(i))
					.Path = brw.FD_GetFileName(i)
					.ClientPath = brw.FD_GetFileHeaderName(i)
					.FormName = brw.FD_GetFileFormName(i)
					.ContentType = brw.FD_GetFileContentType(i)
					.HeadersCount = brw.FD_GetFileHeadersCount(i)
					.Exists = CBool(brw.FExists(brw.FD_GetFileName(i)))
				end with
				nfile.IsOK = (nfile.Exists AND nfile.Size>0)
				if Len(nfile.ClientPath)>0 then
					if not dictFiles.Exists(CStr(nfile.FormName)) then dictFiles.Add CStr(nfile.FormName), Cstr(i)
					for ii = 0 to (nfile.HeadersCount-1)
						nfile.AddHeader ii, brw.FD_GetFileHeader(i,ii)
					next
					FilesCount = FilesCount + 1
					ReDim Preserve m_files(FilesCount-1)
					set m_files(FilesCount-1) = nfile
				end if
			next
		end if
	End Sub

	' END METHODS '
	' BEGIN FUNCTIONS '
	
	Public Function Form(fname)
		Form = "" 
		if HasForm then
			if dictForm.Exists(fname) then
				Form = dictForm(fname)
			end if
		end if
	end function

	Public Function FormItem(fname)
		dim fi
		set fi = new cFormItem 
		if HasForm then
			if dictForm.Exists(CStr(fname)) then
				for i = 0 to UBound(m_formitems)
					if m_formitems(i).Name = fname then
						set fi = m_formitems(i)
						Exit For
					end if
				next
			end if
		end if
		set FormItem = fi
	end function
	
	Public Function File(i_file)
		dim tmpFile
		set tmpFile = new cFile
		Select case TypeName(i_file)
		case  "Integer", "Long" 
			if i_file >=0 AND i_file <= (FilesCount-1) then Set tmpFile = m_files(i_file)
		case "String"
			if IsObject(dictFiles) then
				if dictFiles.Exists(i_file) then Set tmpFile = m_files(CLng(dictFiles(i_file)))
			end if
		end select
		set File = tmpFile
	End Function

	' END FUNCTIONS '
End Class

Class cFile ' uploadovan soubor '
	Public Exists, Name, NameOnly, Extension, Size, Path, IsOK
	Public ClientPath, FormName, ContentType, Headers()
	dim m_headerscount
	Private Sub Class_Initialize()
		Exists = false 	' temp file je na disku? (true / false) '
		Name = ""		' nazev filu u klienta vcetne pripony '
		NameOnly = ""	' nazev filu u klienta bez pripony '
		Extension = ""	' pripona filu bez tecky '
		Size = 0		' velikost v B '
		Path = ""		' cesta tmp filu '
		ClientPath = ""	' plny klienstky nazev filu '
		FormName = ""	' nazev formularoveho prvku '
		ContentType = "" ' contenttype - dodava browser '
		HeadersCount = 0 ' pocet hlavicek '
		IsOK = false	' true / false - true: Exists AND Size > 0 '
	End sub
	Public Property Let HeadersCount(i_headerscount)
		m_headerscount = i_headerscount
		if m_headerscount>0 then Redim Preserve Headers(m_headerscount-1)
	End Property
	Public Property Get HeadersCount()
		HeadersCount = m_headerscount
	End Property
	Public Property Get Properties()
		Properties = Array("Exists","Name","NameOnly","Extension","Size","Path","ClientPath","FormName","ContentType","HeadersCount","IsOK")
	End Property
	
	Public Sub AddHeader(i, someheader)
		if i >= LBound(Headers) AND i <= Ubound(Headers) then Headers(i) = someheader
	end sub
	
	Public Function GetPropertyValue(i_propname)
		dim tmp, i
		GetPropertyValue = Empty
		tmp = Properties
		for i = 0 to UBound(tmp)
			if Cstr(tmp(i)) = CStr(i_propname) then
				GetPropertyValue = PropertyValue(i)
				Exit For
			end if
		next
	end function
	Private Function PropertyValue(i_prop)
		dim tmp
		tmp = Array(Exists,Name,NameOnly,Extension,Size,Path,ClientPath,FormName,ContentType,HeadersCount,IsOK)
		PropertyValue = tmp(i_prop)
	End Function	
End Class

Class cFormItem
	Public Name, Values
	dim m_count
	Private Sub Class_Initialize()
		Name = ""
		Count = 0
		Values = Array()
	end sub
	Private Property Let Count(i_count)
		m_count = i_count
		if m_count>0 then Redim Preserve Values(m_count-1)
	End Property
	Public Property Get Count()
		Count = m_count
	End Property
	Public Sub AddValue(i_value)
		Count = Count + 1
		Values(Count-1) = i_value
	end sub
End Class

</script>
